#include "HistorieServer.h"
#include <Zeit.h>
#include <iostream>
#include <fstream>
#include <Globals.h>
#include <sys/resource.h>

int main()
{
	struct rlimit core_limits;
	core_limits.rlim_cur = core_limits.rlim_max = RLIM_INFINITY;
	setrlimit(RLIMIT_CORE, &core_limits);

    Framework::initFramework();
	Zeit *z = getZeit();
	Text *pfad = new Text( "../log/historie/" );
	pfad->append( z->getZeit( "y-m-d h-i-s.log" ) );
	z->release();
	DateiPfadErstellen( pfad->getThis() );
	std::ofstream file;
	file.open( pfad->getText() );
	std::streambuf* sbuf = std::cout.rdbuf();
	std::cout.rdbuf( file.rdbuf() );
	pfad->release();

	std::cout << "HS: Startet...\n";
	std::cout << "HS: Lese init Datei ../data/hsInit.ini ...\n";
	InitDatei *dat = new InitDatei( "../data/hsInit.ini" );
	if( !dat->laden() )
	{
		std::cout << "HS: error: Datei konnte nicht gelesen werden. Das Programm wird geschlossen.\n";
		dat->release();
		exit( 1 );
	}
    const char *wichtig[] = { "ServerId", "DBBenutzer", "DBPasswort", "DBName", "DBIP", "DBPort", "Aktiv", "SpielHistoriePfad", "SSLPasswort", "SSLCert", "SSLKey" };
    for( const char *w : wichtig )
    {
        if( !dat->wertExistiert( w ) )
        {
            std::cout << "HS: error: Der Wert '" << w << "' wurde nicht gefunden. Das Programm wird geschlossen.\n";
            dat->release();
            exit( 1 );
        }
    }

	HistorieServer *hServer = new HistorieServer( dat );

	std::cout << "HS: Der Admin Server läuft. Startforgang beendet.\n";
	hServer->runn();

	hServer->ende();
	hServer->release();
	dat->release();
	std::cout << "HS: Der Server ist heruntergefahren.\n";
	file.close();
	std::cout.rdbuf( sbuf );
    Framework::releaseFramework();
	return 0;
}